#!/bin/bash
# sip-talk - send a voice message
# 12.01.2009 fk@kworx.de
# http://www.kworx.de/nagios-sprachmeldungen-mit-sip/ 

# config:
SIPREALM=sipgate.de
LINPHONERC=/home/bananapi/callout/linphone.cfg	# path to linphonerc
CALLDURATION=30			# max call duration in seconds
TMPDIR=/var/tmp
LINPHONEC=/usr/bin/linphonec
EXPECT=/usr/bin/expect
TEXT2WAVE=/usr/bin/espeak
# end config
 
function usage(){
	echo "usage: $0 -r -m \"<message>\""
	exit 1
}
 
if [ $# -lt 2 ]; then
	usage
fi
 
while getopts "r:m:" OPTION; do
	case $OPTION in
		r)
			RECIPIENT="sip:$OPTARG@$SIPREALM"
		;;
		m)
			MESSAGE="$OPTARG"
		;;
		*)
			usage
		;;
 
	esac
done
 
# check values
if [ "$RECIPIENT" = "" ]; then
	usage
fi
if [ "$MESSAGE" = "" ]; then
	usage
fi
# check binaries
if [ ! -x "$LINPHONEC" ]; then
	echo "$LINPHONEC not found!"
	exit 1
fi
if [ ! -f "$LINPHONERC" ]; then
	echo "$LINPHONERC not found!"
	exit 1
fi
if [ ! -x "$EXPECT" ]; then
	echo "$EXPECT not found!"
	exit 1
fi
if [ ! -x "$TEXT2WAVE" ]; then
	echo "$TEXT2WAVE not found!"
	exit 1
fi
 
DATE=`date +%y%m%d%k%M|sed 's/ /0/'`
# generate message
MSGWAV=$TMPDIR/$DATE.$RANDOM.wav

$TEXT2WAVE -vde -s 120 -w $MSGWAV << EOF
$MESSAGE
EOF

# execute linphonec
while [ -f $TMPDIR/linphonec ]; do
        sleep 10
done

touch $TMPDIR/linphonec

$EXPECT << EOF 
spawn $LINPHONEC -c $LINPHONERC
expect "linphonec> " {send "soundcard use files\r"}
expect "linphonec> "
sleep 5
send "call $RECIPIENT\r"
expect "linphonec>; Connected."
sleep 1
send "play $MSGWAV\r"
#send "play ./mbrola.wav\r"
sleep $CALLDURATION
send "terminate all\r"
send "quit\r"
EOF
 
# cleanup
rm -f $MSGWAV
rm -f $TMPDIR/linphonec
